<?php
/**
 * AA-Team - http://www.aa-team.com
 * ===============================+
 *
 * @package		flatCountdown_AdminMenu
 * @author		Andrei Dinca
 * @version		1.0
 */
! defined( 'ABSPATH' ) and exit;

if (class_exists('flatCountdown_AdminMenu') != true) {
	class flatCountdown_AdminMenu {
		
		/*
		* Some required plugin information
		*/
		const VERSION = '1.0';

		/*
		* Store some helpers config
		*/
		public $the_plugin = null;
		private $the_menu = array();
		private $current_menu = '';
		private $ln = '';
		
		private $menu_depedencies = array();

		protected static $_instance;

		/*
		* Required __construct() function that initalizes the AA-Team Framework
		*/
		public function __construct() {
			global $flatCountdown;
			$this->the_plugin = $flatCountdown;
			
			// update the menu tree
			$this->the_menu_tree();
			
			return $this;
		}

		public static function getInstance() {
			if (!self::$_instance) {
				self::$_instance = new self();
			}

			return self::$_instance;
		}
		
		private function the_menu_tree() {
			if ( isset($this->the_plugin->cfg['modules']['depedencies']['folder_uri'])
				&& !empty($this->the_plugin->cfg['modules']['depedencies']['folder_uri']) ) {
				$this->menu_depedencies['depedencies'] = array( 
					'title' => esc_html__('Plugin depedencies', 'wordpress-flat-countdown' ),
					'url' => admin_url('admin.php?page=flatCountdown'),
					'folder_uri' => $this->the_plugin->cfg['paths']['freamwork_dir_url'],
					'menu_icon' => 'images/16_dashboard.png'
				);
				return true;
			}

			$this->the_menu['dashboard'] = array( 
				'title' => esc_html__('Dashboard', 'wordpress-flat-countdown' ),
				'url' => admin_url('admin.php?page=flatCountdown#!/dashboard'),
				'folder_uri' => $this->the_plugin->cfg['paths']['freamwork_dir_url'],
				'menu_icon' => 'images/16_dashboard.png'
			);
			
			$this->the_menu['plugin_options'] = array( 
				'title' => esc_html__('PLugin Options', 'wordpress-flat-countdown' ),
				'url' => admin_url('admin.php?page=flatCountdown#!/plugin_options'),
				'folder_uri' => $this->the_plugin->cfg['modules']['plugin_options']['folder_uri'],
				'menu_icon' => 'assets/layout16.png'
				
			);
			
			$this->the_menu['general'] = array( 
				'title' => esc_html__('Plugin Settings', 'wordpress-flat-countdown' ),
				'url' => '#!/',
				'folder_uri' => $this->the_plugin->cfg['paths']['freamwork_dir_url'],
				'menu_icon' => 'images/16_pluginsett.png',
				'submenu' => array(
					'modules_manager' => array(
						'title' => esc_html__('Modules Manager', 'wordpress-flat-countdown' ),
						'url' => admin_url('admin.php?page=flatCountdown#!/modules_manager'),
						'folder_uri' => $this->the_plugin->cfg['modules']['modules_manager']['folder_uri'],
						'menu_icon' => 'assets/16_modules.png'
					),
					
					'setup_backup' => array(
						'title' => esc_html__('Setup / Backup', 'wordpress-flat-countdown' ),
						'url' => admin_url('admin.php?page=flatCountdown#!/setup_backup'),
						'folder_uri' => $this->the_plugin->cfg['modules']['setup_backup']['folder_uri'],
						'menu_icon' => 'assets/16_setupbackup.png'
					),
					
					'remote_support' => array(
						'title' => esc_html__('Remote Support', 'wordpress-flat-countdown' ),
						'url' => admin_url('admin.php?page=flatCountdown_remote_support'),
						'folder_uri' => $this->the_plugin->cfg['modules']['remote_support']['folder_uri'],
						'menu_icon' => 'assets/16_remotesupport.png'
					),
				)
			);
		}
		
		public function show_menu( $pluginPage = '' ) {
			$plugin_data = $this->the_plugin->get_plugin_data();
			
			$html = array();
			// id="flatCountdown-nav-dashboard" 
			$html[] = '<div id="flatCountdown-header">';
			$html[] = 	'<div id="flatCountdown-header-bottom">';
			$html[] = 		'<div id="flatCountdown-topMenu">';
			$html[] = 			'<a href="#" target="_blank" class="flatCountdown-product-logo">
									<img src="' . ( $this->the_plugin->cfg['paths']['plugin_dir_url'] ) . 'thumb.png">
									<h2>Responsive Coming Soon Landing Page</h2>
									<h3>' . ( $plugin_data['version'] ) . '</h3>
									
									<span class="flatCountdown-rate-now"></span>
									<img src="' . ( $this->the_plugin->cfg['paths']['freamwork_dir_url'] ) . 'images/rate-now.png" class="flatCountdown-rate-img">
									<img src="' . ( $this->the_plugin->cfg['paths']['freamwork_dir_url'] ) . 'images/star.gif" class="flatCountdown-rate-gif">
									<strong>Don’t forget to rate us!</strong>
								</a>';
			$html[] = 			'<ul>';

			if ( $pluginPage == 'depedencies' ) {
				$menu = $this->menu_depedencies;
				$this->current_menu = array(
					0 => 'depedencies',
					1 => 'depedencies'
				);
			} else {
				$menu = $this->the_menu;
			}

			foreach ($menu as $key => $value) {
				$iconImg = '<img src="' . ( $value['folder_uri'] . $value['menu_icon'] ) . '" />';
				$html[] = '<li id="flatCountdown-nav-' . ( $key ) . '" class="flatCountdown-section-' . ( $key ) . ' ' . ( isset($this->current_menu[0]) && ( $key == $this->current_menu[0] ) ? 'active' : '' ) . '">';
									
				if ( $value['url'] == '#!/' ) {
					$value['url'] = 'javascript: void(0)';
				}
				$html[] = 	'<a href="' . ( $value['url'] ) . '">' . ( $iconImg ) . '' . ( $value['title'] ) . '</a>';
				if ( isset($value['submenu']) ) {
					$html[] = 	'<ul class="flatCountdown-sub-menu">';
					foreach ($value['submenu'] as $kk2 => $vv2) {
						if ( ( $kk2 != 'synchronization_log' ) && isset($this->the_plugin->cfg['activate_modules']) && is_array($this->the_plugin->cfg['activate_modules']) && !in_array( $kk2, array_keys($this->the_plugin->cfg['activate_modules'])) ) {
							continue;
						}
		
						$iconImg = '<img src="' . ( $vv2['folder_uri'] . $vv2['menu_icon'] ) . '" />';
						$html[] = '<li class="flatCountdown-section-' . ( $kk2 ) . '  ' . ( isset($this->current_menu[1]) && $kk2 == $this->current_menu[1] ? 'active' : '' ) . '" id="flatCountdown-sub-nav-' . ( $kk2 ) . '">';
						$html[] = 	$iconImg;
						$html[] = 	'<a href="' . ( $vv2['url'] ) . '">' . ( $vv2['title'] ) . '</a>'; 
											
						if ( isset($vv2['submenu']) ) {
							$html[] = 	'<ul class="flatCountdown-sub-sub-menu">';
							foreach ($vv2['submenu'] as $kk3 => $vv3) {
								$html[] = '<li id="flatCountdown-sub-sub-nav-' . ( $kk3 ) . '">';
								$html[] = 	'<a href="' . ( $vv3['url'] ) . '">' . ( $vv3['title'] ) . '</a>';
								$html[] = '</li>';
							}
							$html[] = 	'</ul>';
						}
						$html[] = '</li>';
					}
					$html[] = 	'</ul>';
				}
				$html[] = '</li>';
			}
			$html[] = 			'</ul>';
			$html[] = 		'</div>';
			$html[] = 	'</div>';
			
			$html[] = 	'<a href="http://codecanyon.net/user/AA-Team/portfolio?ref=AA-Team" class="flatCountdown-aateam-logo">AA-Team</a>';
			
			$html[] = '</div>';
			
			/*$html[] = '<script>
			(function($) {
				var flatCountdownMenu = $("#flatCountdown-topMenu");
				
				flatCountdownMenu.on("click", "a", function(e){
					
					var that = $(this),
						href = that.attr("href");
					
					if( href == "javascript: void(0)" ){
						var current_open = flatCountdownMenu.find("li.active");
						current_open.find(".flatCountdown-sub-menu").slideUp(350);
						current_open.removeClass("active");
						
						that.parent("li").eq(0).find(".flatCountdown-sub-menu").slideDown(350, function(){
							that.parent("li").eq(0).addClass("active");
						});
					}
				});
			})(jQuery);
			</script>';*/
			
			echo implode("\n", $html);
		}

		public function make_active( $section = '' ) {
			$this->current_menu = explode('|', $section);
			return $this;
		}
	}
}
